import { BareAppConfig, ExpoConfig } from '@expo/config';
import Minipass from 'minipass';
import { PackageSpec } from 'pacote';
import { ReadEntry } from 'tar';
declare type AppJsonInput = {
    expo: Partial<ExpoConfig> & {
        name: string;
    };
};
declare type TemplateConfig = {
    name: string;
};
declare class Transformer extends Minipass {
    config: TemplateConfig;
    private settings;
    data: string;
    constructor(config: TemplateConfig, settings: {
        extension: string;
    });
    write(data: string): boolean;
    getNormalizedName(): string;
    end(): void;
}
export declare function createFileTransform(config: TemplateConfig): (entry: ReadEntry) => Transformer | undefined;
/**
 * Extract a template app to a given file path and clean up any properties left over from npm to
 * prepare it for usage.
 */
export declare function extractAndPrepareTemplateAppAsync(templateSpec: PackageSpec, projectRoot: string, config: AppJsonInput | BareAppConfig): Promise<string>;
/**
 * Extract a template app to a given file path.
 */
export declare function extractTemplateAppAsync(templateSpec: PackageSpec, targetPath: string, config: TemplateConfig): Promise<string>;
export declare function extractTemplateAppFolderAsync(tarFilePath: string, targetPath: string, config: TemplateConfig): Promise<string>;
export declare function createEntryResolver(name: string): (entry: ReadEntry) => void;
export {};
